program cd2tex; (* Thomas Klein  05/02, 11/04, 10/07 *)
uses dos,unix;
var filename,textleft,textright,dtitle:string;
    tsize,dsize,i,rotate,maxdepth:integer;
    wrt,mp3:boolean;
    datein,dataus:text;
    
procedure cddir(path:string;depth:integer);
 var entry:searchrec;
     firsttrack:boolean;
     returncode:longint;
     line:string;

 procedure prtentry(entry:string);
  begin
   if mp3 then begin
    if (copy(entry,length(entry)-3,4)='.mp3') or (copy(entry,length(entry)-3,4)='.MP3') then begin
     delete(entry,length(entry)-3,4);
     if (length(entry)>=3) and (entry[1] in ['0'..'9']) and (entry[2] in ['0'..'9']) and (entry[3]='_') then
      delete(entry,1,3);
     if (length(entry)>=2) and (entry[1] in ['0'..'9']) and (entry[2]='_') then
      delete(entry,1,2);
    end;
   end;
   for i:=1 to length(entry) do begin
    case entry[i] of
     '"': write(#39);
     '_': write('\_');
     '&': write('\&');
     else write(entry[i]);
    end;
   end;
   wrt:=true;
  end;

 begin
  if path[length(path)]<>'/' then path:=path+'/';
  assign(dataus,'/tmp/cd-unsort.tmp'); rewrite(dataus);
  findfirst(path+'*',anyfile,entry);
  while doserror=0 do begin
   if (entry.attr<>directory) and
      (entry.attr<>17) and
      (entry.name<>'.') and
      (entry.name<>'..')
   then
    writeln(dataus,entry.name);
   findnext(entry)
  end;
  close(dataus);
  returncode:=shell('sort /tmp/cd-unsort.tmp >/tmp/cd-sort.tmp');
  firsttrack:=true;
  assign(datein,'/tmp/cd-sort.tmp'); reset(datein);
  while not(eof(datein)) do begin
   readln(datein,line);
   if firsttrack then firsttrack:=false else writeln(' $\cdot$');
   write(' '); prtentry(line); write(' ');
  end;
  close(datein);
  returncode:=shell('rm /tmp/cd-unsort.tmp /tmp/cd-sort.tmp');
  findfirst(path+'*',anyfile,entry);
  while doserror=0 do begin
   if ((entry.attr=directory) or (entry.attr=17)) and (entry.name<>'.') and (entry.name<>'..') then begin
    if (depth=0) and (wrt=true) then writeln(' \\');
    if depth<>0 then write(' $\circ$ ');
    if tsize=1 then write(' \textit{') else write(' \textbf{');
    prtentry(entry.name);
    if depth<maxdepth then begin
     writeln(':} '); cddir(path+entry.name,depth+1);
    end else
     writeln('} ');
    if depth>0 then writeln(' $\bullet$ ');
   end;
   findnext(entry);
  end;
  findclose(entry);
 end;

procedure writetitle(title:string;rotate:integer);
 var i:integer;
 begin
  if rotate<>0 then begin
   writeln('\begin{turn}{',rotate,'}');
   writeln(dtitle);
   writeln('\end{turn}');
  end else begin
   write('\shortstack{');
   for i:=1 to length(title) do begin
    write(title[i]);
    if i<>length(title) then write('\\');
   end;
   writeln('}');
  end;
 end;

begin
 if paramcount<=9 then begin
  if paramcount>=1 then filename:=paramstr(1) else filename:='/cdrom/';
  if paramcount>=2 then dtitle:=paramstr(2) else dtitle:='';
  maxdepth:=255;
  if paramcount>=6 then begin
   val(paramstr(6),maxdepth,i); if i<>0 then maxdepth:=255;
  end;
  mp3:=not((paramcount>=7) and (paramstr(7)='0'));
  if paramcount>=3 then textleft:=paramstr(3) else textleft:='';
  if paramcount>=4 then textright:=paramstr(4) else textright:='';
  tsize:=3;
  if paramcount>=5 then begin
   val(paramstr(5),tsize,i); if i<>0 then tsize:=3;
  end;
  dsize:=0;
  if paramcount>=8 then begin
   val(paramstr(8),dsize,i); if i<>0 then dsize:=6;
  end;
  if (paramcount=9) and (paramstr(9)='0') then rotate:=0 else rotate:=90;
  if textleft='.' then textleft:='';
  while pos('_',textleft)<>0 do textleft[pos('_',textleft)]:=' ';
  if textright='.' then textright:='';
  while pos('_',textright)<>0 do textright[pos('_',textright)]:=' ';
  if dtitle='.' then dtitle:='';
  while pos('_',dtitle)<>0 do dtitle[pos('_',dtitle)]:=' ';
  
  writeln('% cd-cover  stk  05/02');
  writeln('\documentclass[10pt]{article}');
  writeln('\usepackage{german}');
  writeln('\usepackage{a4}');
  writeln('\usepackage[latin1]{inputenc}');
  writeln('\usepackage[T1]{fontenc}');
  writeln('\usepackage{rotating}');
  writeln;
  writeln('\setlength{\textwidth}{150mm}');
  writeln('\setlength{\oddsidemargin}{4mm}');
  writeln('\setlength{\topmargin}{-25mm}');
  writeln('\setlength{\parindent}{0mm}');
  writeln('\renewcommand{\baselinestretch}{0.8}');
  writeln('\pagestyle{empty}');
  writeln;
  writeln('\begin{document}');
  writeln;
  writeln('\setlength{\unitlength}{1.00mm}');

  if dsize=0 then begin
   writeln('\begin{picture}(121.00,119.00)(0.00,0.00)');
   writeln('\sffamily');
   writeln;
   writeln('\put(0,0){\framebox(121,119){');
   writeln('\begin{minipage}[t][115mm]{117mm}');
  end else begin
   writeln('\begin{picture}(150.00,117.00)(0.00,0.00)');
   writeln('\sffamily');
   writeln;
   writeln('\put(0,0){\framebox(150,117){');
   writeln('\begin{minipage}[t][110mm]{130mm}');
  end;

  case tsize of
   1: writeln('\tiny');
   2: writeln('\scriptsize');
   3: writeln('\footnotesize');
   4: writeln('\small');
   5: writeln('\normalsize');
   6: writeln('\large');
   7: writeln('\Large');
   8: writeln('\LARGE');
  else
   writeln('\footnotesize');
  end;
  if (dsize=0) and (dtitle<>'') then writeln('\underline{',dtitle,'} \\ \\');
  wrt:=false; cddir(filename,0);
  writeln;
  if tsize>3 then writeln('\footnotesize');
  writeln('\vfill');
  write(textleft); if textright<>'' then writeln(' \hfill ',textright);
  writeln('\end{minipage}');
  writeln('}}');
  if dsize<>0 then begin
   case dsize of
    1: writeln('\tiny');
    2: writeln('\scriptsize');
    3: writeln('\footnotesize');
    4: writeln('\small');
    5: writeln('\normalsize');
    6: writeln('\large');
    7: writeln('\Large');
    8: writeln('\LARGE');
   else
    writeln('\large');
   end;
   writeln('\put(0,0){\framebox(6,117){');
   write('\begin{minipage}[');
   if rotate=0 then write('t') else write ('b');
   writeln('][110mm]{6mm}');
   writeln('\begin{center}');
   writetitle(dtitle,rotate);
   writeln('\end{center}');
   writeln('\end{minipage}');
   writeln('}}');
   writeln('\put(144,0){\framebox(6,117){');
   writeln('\begin{minipage}[t][110mm]{6mm}');
   writeln('\begin{center}');
   writetitle(dtitle,-rotate);
   writeln('\end{center}');
   writeln('\end{minipage}');
   writeln('}}');
  end;
  writeln('\end{picture}');
  writeln;
  writeln('\end{document}');
 end else
  writeln(paramstr(0),' [directory] [disctitle] [left-text] [right-text] [fontsize (1-8, normal: 3)] [maxdepth] [mp3 (1/0)] [size of title (1-8, normal: 6, no (std/front-cover): 0 ] [title-rotation (1/0)]');
end.
