program cddb2tex; (* Thomas Klein  05/02, 11/04, 10/07 *)
uses unix;
const maxtrack=99;
      tracklines=22;
var datein:text;
    textleft,textright,dtitle:string;
    ttimes,ttitle:array [1..maxtrack] of string;
    tsize,track,i,rotate:integer;
    
procedure getinfo;
 var line:string;
     entry,p:integer;
     ttime,last:longint;
     ende:boolean;

 function readline:string;
  var line,newline,c:string;
      i:integer;
  begin
   readln(datein,line);
   newline:='';
   for i:=1 to length(line) do begin
    case line[i] of
     '_': c:='\_';
     '}': c:='\}';
     '{': c:='\{';
     '&': c:='\&';
    else
     c:=line[i];
    end;
    newline:=newline+c;
   end;
   (* writeln(newline); *)
   readline:=newline;
  end;
 function calctime(ttime:longint):string;
  var timem,times:string;
      ttime0:longint;
  begin
   ttime:=ttime div 75;
   ttime0:=ttime div 60; str(ttime0:2,timem);
   ttime0:=ttime mod 60; str(ttime0:2,times); 
   if times[1]=' ' then times[1]:='0';
   calctime:=timem+':'+times;
  end;

 begin
  ende:=false; track:=0;
  repeat
   line:=readline;
   
   if pos('Track frame offsets:',line)>0 then begin
    entry:=-1; ende:=false; last:=0;
    repeat
     line:=readline;
     if length(line)<3 then begin
      line:=readline;
      inc(entry); delete(line,1,15);
      val(line,ttime,p);
      if p<>0 then val(copy(line,1,p-1),ttime,p);
      ttimes[entry]:=calctime(ttime*75-last);
      ende:=true;
     end else begin
      inc(entry); val(copy(line,2,length(line)-1),ttime,p);
      if entry>0 then begin
       ttimes[entry]:=calctime(ttime-last);
      end;
      last:=ttime;
     end;
    until (ende) or (eof(datein));
   end;

   if copy(line,1,7)='DTITLE=' then
    dtitle:=copy(line,8,length(line)-7);
   if copy(line,1,6)='TTITLE' then begin
    while pos('"',line)<>0 do line[pos('"',line)]:=#39;
    inc(track); p:=pos('=',line);
    ttitle[track]:=copy(line,p+1,length(line)-p);
   end;

  until eof(datein);
 end;

procedure writetitle(title:string;rotate:integer);
 var i:integer;
 begin
  if rotate<>0 then begin
   writeln('\begin{turn}{',rotate,'}');
   writeln(dtitle);
   writeln('\end{turn}');
  end else begin
   write('\shortstack{');
   for i:=1 to length(title) do begin
    write(title[i]);
    if i<>length(title) then write('\\');
   end;
   writeln('}');
  end;
 end;

begin
 if paramcount in [1..5] then begin
  tsize:=5;
  if paramcount>=2 then begin
   val(paramstr(2),tsize,i); if i<>0 then tsize:=5;
  end;
  if paramcount>=2 then textleft:=paramstr(2) else textleft:='';
  if paramcount>=3 then textright:=paramstr(3) else textright:='';
  tsize:=6;
  if paramcount>=4 then begin
   val(paramstr(4),tsize,i); if i<>0 then tsize:=6;
  end;
  if (paramcount=5) and (paramstr(5)='0') then rotate:=0 else rotate:=90;
  if textleft='.' then textleft:='';
  while pos('_',textleft)<>0 do textleft[pos('_',textleft)]:=' ';
  if textright='.' then textright:='';
  while pos('_',textright)<>0 do textright[pos('_',textright)]:=' ';
  assign(datein,paramstr(1)); reset(datein);
  getinfo;
  close(datein);
  
  writeln('% cd-cover  stk  05/02');
  writeln('\documentclass[10pt]{article}');
  writeln('\usepackage{german}');
  writeln('\usepackage{a4}');
  writeln('\usepackage[latin1]{inputenc}');
  writeln('\usepackage[T1]{fontenc}');
  writeln('\usepackage{rotating}');
  writeln;
  writeln('\setlength{\textwidth}{150mm}');
  writeln('\setlength{\oddsidemargin}{4mm}');
  writeln('\setlength{\topmargin}{-25mm}');
  writeln('\setlength{\parindent}{0mm}');
  writeln('\pagestyle{empty}');
  writeln;
  writeln('\begin{document}');
  writeln;
  writeln('\setlength{\unitlength}{1.00mm}');

  if tsize=0 then begin
   writeln('\begin{picture}(121.00,119.00)(0.00,0.00)');
   writeln('\sffamily');
   writeln;
   writeln('\put(0,0){\framebox(121,119){');
   writeln('\begin{minipage}[t][115mm]{117mm}');
  end else begin
   writeln('\begin{picture}(150.00,117.00)(0.00,0.00)');
   writeln('\sffamily');
   writeln;
   writeln('\put(0,0){\framebox(150,117){');
   writeln('\begin{minipage}[t][110mm]{130mm}');
  end;
  writeln('\underline{',dtitle,'} \\ \\');
  if track>tracklines then writeln('\footnotesize');
  for i:=1 to track do begin
   if (track>9) and (i<10) then write('0');
   writeln(i,'. ',ttitle[i],' \hfill ',ttimes[i],' \\');
  end;
  writeln('\vfill');
  if track>tracklines then
   writeln('\scriptsize')
  else
   writeln('\footnotesize');
  write(textleft); if textright<>'' then writeln(' \hfill ',textright);
  writeln('\end{minipage}');
  writeln('}}');
  if tsize<>0 then begin
   case tsize of
    1: writeln('\tiny');
    2: writeln('\scriptsize');
    3: writeln('\footnotesize');
    4: writeln('\small');
    5: writeln('\normalsize');
    6: writeln('\large');
    7: writeln('\Large');
    8: writeln('\LARGE');
   else
    writeln('\large');
   end;
   writeln('\put(0,0){\framebox(6,117){');
   write('\begin{minipage}[');
   if rotate=0 then write('t') else write ('b');
   writeln('][110mm]{6mm}');
   writeln('\begin{center}');
   writetitle(dtitle,rotate);
   writeln('\end{center}');
   writeln('\end{minipage}');
   writeln('}}');
   writeln('\put(144,0){\framebox(6,117){');
   writeln('\begin{minipage}[t][110mm]{6mm}');
   writeln('\begin{center}');
   writetitle(dtitle,-rotate);
   writeln('\end{center}');
   writeln('\end{minipage}');
   writeln('}}');
  end;
  writeln('\end{picture}');
  writeln;
  writeln('\end{document}');
 end else
  writeln(paramstr(0),' filename [left-text] [right-text] [size of title (1-8, normal: 6, no (front-cover): 0)] [title-rotation (1/0)]');
end.
