#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

# Frontend for cddblist  Thomas Klein  10/07

proc refresh {dir} {
 global cddb
 set cddb [list]
 if {[catch "exec cddblist $dir tyn 60 >/tmp/cddblist[pid].tmp"]==0} {
  set in [open "/tmp/cddblist[pid].tmp" r]
  while {[gets $in line] != -1} {
   lappend cddb $line
  }
  close $in
 }
 exec rm /tmp/cddblist[pid].tmp
 set cddb [lsort -dictionary $cddb] 
}

if {$argc>0} {set dir [lindex $argv 0]} else {set dir "$env(HOME)/.cddb"}
refresh $dir

frame .fdir
entry .edir -textvariable dir
button .bdir -text "Choose Dir" -command {
 set dir [tk_chooseDirectory -initialdir $dir] ; refresh $dir
}
pack .edir .bdir -in .fdir -side left -fill x -expand 1
bind .edir <Key-Return> { refresh $dir }

frame .fbox
listbox .lb -listvariable cddb -xscrollcommand ".scrx set" -yscrollcommand ".scry set" -selectmode single -width 66 -height 20 -font "courier 9"
scrollbar .scry -command ".lb yview" -orient v
pack .lb .scry -in .fbox -side left -fill y
scrollbar .scrx -command ".lb xview" -orient h

frame .fbuttons
button .brun -text "Run" -width 4 -command {
 set i [.lb curselection]
 if {$i!=""} {
  set album [lindex $cddb $i]
  catch "exec cddb2tex.tcl [string range $album 68 end] \"\" \"\" [string range $album 62 65] &"
 }
}
button .bquit -text "Quit" -width 4 -command exit
pack .brun .bquit -in .fbuttons -side left -expand 1

pack .fdir .fbox .scrx .fbuttons -fill x
